function love.load()
	can = love.graphics.newCanvas(50, 50)
end



function saveScreenshot()
	love.graphics.newScreenshot():encode("png", string.format("screenshot-%s.png", os.date("%Y-%m-%d-%H-%M-%S")))
end



function love.keypressed(keyConstant, scanCode, isRepeat)
	if keyConstant == "printscreen" then		--printscreen to save screenshot to AppData\local\LOVE
		if not isRepeat then
			saveScreenshot()
		end
	elseif keyConstant == 'f11' then		--F11 to toggle fullscreen
		if not isRepeat then
			love.window.setFullscreen(not love.window.getFullscreen())
		end
	end
end



function love.draw()
	love.graphics.setCanvas(can)
	do
		love.graphics.clear(0, 0, 0)			--add black background
		love.graphics.setColor(255, 255, 255)
		love.graphics.points(0, 0, can:getWidth()-1, can:getHeight()-1)		--draw canvas points
	end

	love.graphics.setCanvas()
	
	love.graphics.setColor(255, 0, 0)
	love.graphics.rectangle('fill', 50, 50, 52, 52)		--this is 'fill' so that we can inspect the actual dimensions of canvas
	
	love.graphics.setColor(0, 255, 0)
	for i = 1, 50 do						--checking the width of canvas got me confused
		love.graphics.points(i+50, 49)
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(can, 51, 51)
	
	love.graphics.setColor(0, 0, 255)
	love.graphics.rectangle('fill', love.graphics.getWidth()-50, love.graphics.getHeight()-50, 100, 100)	--overflowing rectangle visible in windowed - bottom right
	love.graphics.rectangle('fill', 50, 50, -100, -100)	--overflow not visible
	love.graphics.setColor(255, 0, 0)
	love.graphics.points(0, 0, love.graphics.getWidth(), love.graphics.getHeight())	--overflowing pixel not visible
	love.graphics.setColor(255, 255, 255)
	love.graphics.points(0, 1, love.graphics.getWidth()-1, love.graphics.getHeight())	--visible pixels
	
    love.graphics.print(string.format("Version %d.%d.%d - %s", love.getVersion()), 20, 20)
    love.graphics.print(string.format("Window %d %d", love.graphics.getWidth(), love.graphics.getHeight()), 20, 35)
    love.graphics.print(string.format("Canvas %d %d", can:getWidth(), can:getHeight()), 20, 150)
    love.graphics.print("printscreen to save a screenshot in AppData/local/LOVE (Windows), for further inspection (scaling the image)", 20, 170)
    love.graphics.print("F11 to toggle fullscreen", 20, 190)
end
